'--------------------------------------------------------------------------
'
'   SFTP Comparator v0.4
'
'
'   by truhlik (C) 2012
'
'
' release date:
'               27.08.2012
'
' feautures:
'   - Compare SFTP file with selected local file
'
'
' history:
'   0.4  - 27.08.2012
'        - exclude folder from comparison
'   0.3  - 18.08.2012
'        - small bugfixes
'        - smarter target-file prediction
'   0.2  - 31.07.2012
'        - added support for LOCAL x LOCAL
'   0.1  - 31.07.2012
'        - initial release
'
'
'   Required
'       WinSCP application
'
'
'   Limitations
'       Works only for sessions with stored password. Automation plugin does not support password input-box
'
'-------------------------------------------------------------------------------------


'------------------------------------------------------
' Creating objects
'-----------------
Dim Fso, WshShell, Item
Set Fso = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")


'------------------------------------------------------
' Variables
'----------
ABORT_OPTION = """option batch abort"""
CONFIRM_OPTION = """option confirm off"""

'Salamander.SetPersistentVal "compare.winscp", "C:\Program Files\WinSCP\WinScp.com"

'Clear path fom WinSCP
'Salamander.SetPersistentVal "compare.winscp", null

'Clear path For fcremote
'Salamander.SetPersistentVal "compare.fcremote", null

'------------------------------------------------------------------------------------
' T E L O   S K R I P T U
'------------------------------------------------------------------------------------

WinSCP_path = MyGetPersistentVal("compare.winscp", "-1")
fcremote_path = MyGetPersistentVal("compare.fcremote", "-1")

If Not IsFile (WinSCP_path & "\WinSCP.com") Then
    WinSCP_path = SetWinSCPPath
End If

If Not IsFile (fcremote_path & "\fcremote.exe") Then
    fcremote_path = SetComparePath
End If

' Check For required settings
If WinSCP_path = -1 or fcremote_path = -1 Then
    Salamander.MsgBox("Wrong WinSCP or fcremote path")
Else
    DoCompare
End If ' Check for correct path


'-------------------------------------------------------------------------------------
' F U N C T I O N S
'-------------------------------------------------------------------------------------
'-------------------------------------------------------------------------------------
' DoCompare
'  Main Sub for file comparison script
'-------------------------------------
Sub DoCompare
' Pick selected (higher priority) or focused file in source panel

    ' tmp pro path type
    Dim LeftT, RightT
    LeftT = Salamander.LeftPanel.PathType
    RightT = Salamander.RightPanel.PathType

    ' beru pouze vybrany soubor
    Set SouborMainItem = Salamander.SourcePanel.FocusedItem

    ' pokud je ve druhem okne stejne pojmenovany soubor
    For Each Item In Salamander.TargetPanel.Items 
        If Item = Salamander.SourcePanel.FocusedItem Then 
            Set SouborTargetItem = Item
            If Salamander.SourcePanel Is Salamander.RightPanel Then
                Set SouborMainItem = Item
                Set SouborTargetItem = Salamander.RightPanel.FocusedItem
            End If
        End If
    Next

    ' pokud je na aktivnim okne jeden oznacen, rozdilny od focused
    If Salamander.SourcePanel.SelectedItems.Count = 1 Then
        For Each Item In Salamander.SourcePanel.SelectedItems
            Set SouborMainItem = Item
        Next
        If SouborMainItem <> Salamander.SourcePanel.FocusedItem Then 
            Set SouborTargetItem = Salamander.SourcePanel.FocusedItem
        End If
        LeftT = Salamander.SourcePanel.PathType
        RightT = Salamander.SourcePanel.PathType
    End If

    ' pokud je na neaktivnim okne jeden oznacen
    If Salamander.TargetPanel.SelectedItems.Count = 1 And Salamander.SourcePanel.SelectedItems.Count = 0 Then
        Set SouborMainItem = Salamander.LeftPanel.FocusedItem
        Set SouborTargetItem = Salamander.RightPanel.FocusedItem
        For Each Item In Salamander.LeftPanel.SelectedItems
            Set SouborMainItem = Item
        Next
        For Each Item In Salamander.RightPanel.SelectedItems
            Set SouborTargetItem = Item
        Next
    End If

    ' pokud mam oznacen na kazdem okne jeden
    If Salamander.TargetPanel.SelectedItems.Count = 1 And Salamander.SourcePanel.SelectedItems.Count = 1 Then
        For Each Item In Salamander.LeftPanel.SelectedItems
            Set SouborMainItem = Item
        Next
        For Each Item In Salamander.RightPanel.SelectedItems
            Set SouborTargetItem = Item
        Next
    End If

    ' pokud v aktnivnim okne jsou dva oznacene
    If Salamander.SourcePanel.SelectedItems.Count = 2 Then
        For Each Item In Salamander.SourcePanel.SelectedItems
            Set SouborMainItem = Item
            Exit For
        Next
        For Each Item In Salamander.SourcePanel.SelectedItems
            Set SouborTargetItem = Item
        Next
        LeftT = Salamander.SourcePanel.PathType
        RightT = Salamander.SourcePanel.PathType
    End If


'            Salamander.MsgBox("jsem LEFT " & SouborMainItem & " Type " & LeftT)
'            Salamander.MsgBox("jsem RIGHT  " & SouborTargetItem & " Type " & RightT)

    ' check if source or target file is folder
    If IsFolderByClass(SouborMainItem, LeftT) Then SouborMainItem = ""
    If IsFolderByClass(SouborTargetItem, RightT) Then SouborTargetItem = ""

    ContinueCompare = PrepareMainForm (SouborMainItem, SouborTargetItem)
    
    If ContinueCompare = 1 Then

'        Salamander.MsgBox("Main je " & SouborMainItem)
        Set sourceFile = New cFile 
        sourceFile.Initialize SouborMainItem , LeftT
    
'        Salamander.MsgBox("Target je " & SouborTargetItem)
        Set targetFile = New cFile 
        targetFile.Initialize SouborTargetItem, RightT

        ' generating temporary file name
        TempName = Fso.GetSpecialFolder(2)
        TempName = TempName & "\" & Fso.GetTempName

        If (sourceFile.FileSystem = "SFTP" And targetFile.FileSystem = "LOCAL" ) Or (sourceFile.FileSystem = "LOCAL" And targetFile.FileSystem = "SFTP" ) Then
            If sourceFile.IsFile And targetFile.IsFile Then
                ' Only file x file is supported
                If ContinueCompare = 1 Then 
    
                    If sourceFile.FileSystem = "SFTP" Then 
                    ' sftp is focused panel;
                        Command = WinSCP_path & "\WinSCP.com" & " /command " & ABORT_OPTION & " " & CONFIRM_OPTION & " ""open " & sourceFile.Path & """ ""get " & sourceFile.Name & " " & TempName & """ ""exit"""
                    Else
                    ' sftp is unfocused panel
                        Command = WinSCP_path & "\WinSCP.com" & " /command " & ABORT_OPTION & " " & CONFIRM_OPTION & " ""open " & targetFile.Path & """ ""get " & targetFile.Name & " " & TempName & """ ""exit"""
                    End If
                    
    '                Salamander.MsgBox(Command)
                    ErrHolder = WshShell.Run (Command, 0, true)
    
                    If ErrHolder <> 0 Then 
                        Salamander.MsgBox("Error code for WinSCP is: #" & ErrHolder & vbNewLine & "This is probably caused by NOT stored password for SFTP session")
                    Else
    
                        If Fso.FileExists ( TempName ) Then
    
                            If sourceFile.FileSystem = "SFTP" Then 
                            ' sftp is focused panel;
                                Command = """" & fcremote_path & "\fcremote.exe"" -w """ & TempName & """ """ & targetFile.FullPath & """"
                            Else
                            ' sftp is unfocused panel
                                Command = """" & fcremote_path & "\fcremote.exe"" -w """ & sourceFile.FullPath & """ """ & TempName & """"
                            End If
        
    '                        Salamander.MsgBox(Command)
                            ErrHolder = WshShell.Run (Command, 4, True)
        
                            If ErrHolder <> 0 Then 
                                Salamander.MsgBox("Error. File compare returned #" & ErrHolder)
                            Else
                                If Fso.FileExists ( TempName ) Then
                                    Fso.DeleteFile TempName
                                End If
                            End If
                        Else
                            Salamander.MsgBox("Some error uccured and remote file is not ready.")
                        End If
                    End If
                End If ' Continue compare with files
            Else
                Salamander.MsgBox("Comparing directories is not supported.")
            End If
    
        ElseIf sourceFile.FileSystem = "LOCAL" And targetFile.FileSystem = "LOCAL" Then
            If sourceFile.IsFile And targetFile.IsFile Then
                If ContinueCompare = 1 Then
                    Command = """" & fcremote_path & "\fcremote.exe""  """ & sourceFile.FullPath & """ """ & targetFile.FullPath & """"
                    ErrHolder = WshShell.Run (Command)
                End If
            Else
                Salamander.MsgBox("Comparing directories is not supported.")
            End If ' 
        Else
            ' FTP, ARCH, UNK, ....
            Salamander.MsgBox("Compare " & sourceFile.FileSystem & " x " & targetFile.FileSystem & " is not supported.")
        End If
    ElseIf ContinueCompare = 3 Then
        Salamander.MsgBox("Unable to find file '" & SouborMainItem & "' or '" & SouborTargetItem & "'")
    End If
End Sub


'-------------------------------------------------------------------------------------
' PrepareMainForm
'  Create main window
'---------------------
Function PrepareMainForm ( srcPath, trgtPath)
    DoContinue = 2
    If srcPath = "" Or trgtPath = "" Then
        If srcPath = "" And trgtPath <> "" Then
            DoContinue = CreateMainForm (srcPath, trgtPath.Path)
            If DoContinue = 1 And IsFile (srcPath) Then 
                newFile = srcPath
                Set srcPath = Fso.GetFile(newFile)
            ElseIf Not IsFile (srcPath) And DoContinue = 1 Then
                DoContinue = 3
            End If
        ElseIf trgtPath = "" And srcPath <> "" Then
            DoContinue = CreateMainForm (srcPath.Path, trgtPath)
            If DoContinue = 1 And IsFile (trgtPath) Then 
                newFile = trgtPath
                Set trgtPath = Fso.GetFile(newFile)
            ElseIf Not IsFile (trgtPath) And DoContinue = 1 Then
                DoContinue = 3
            End If
        ElseIf trgtPath = "" And srcPath = "" Then
            DoContinue = CreateMainForm (srcPath, trgtPath)
            If DoContinue = 1 And IsFile (trgtPath) Then 
                newFile = trgtPath
                Set trgtPath = Fso.GetFile(newFile)
            ElseIf Not IsFile (trgtPath) And DoContinue = 1 Then
                DoContinue = 3
            End If
        End If
    Else
        DoContinue = CreateMainForm (srcPath.Path, trgtPath.Path)
    End If

    PrepareMainForm = DoContinue
    
End Function



'-------------------------------------------------------------------------------------
' CreateMainForm
'  Prepare main window
'---------------------
Function CreateMainForm(srcPath, trgtPath)
    Dim fm
    Set fm = Salamander.Forms.Form("File Compare")

    ' little hack for expand window
    fm.srcLbl = Salamander.Forms.Label("                                                                                            ")
    fm.srcLbl = Salamander.Forms.Label("Compare file:")
    fm.source = Salamander.Forms.TextBox(srcPath)
    fm.trgLbl = Salamander.Forms.Label("With File:")
    fm.target = Salamander.Forms.TextBox(trgtPath)

    fm.okbtn = Salamander.Forms.Button("Ok", 1)
    fm.cancelbtn = Salamander.Forms.Button("Cancel", 2)
    CreateMainForm = fm.execute
    trgtPath = fm.target.Text
    Set fm = Nothing
End Function


'-------------------------------------------------------------------------------------
' IsFile
'  Check if file exists
'----------------------
Function IsFile(folder)
    IsFile = False
    Dim objFSO
    Set objFSO = CreateObject("Scripting.FileSystemObject")
    If objFSO.FileExists(folder) Then 
    IsFile = True
    End If
    Set objFSO = Nothing
End Function


'-------------------------------------------------------------------------------------
' IsFolderByClass
'  Check if path is folder
'-------------------------
Function IsFolderByClass(folderPath, ftype)
    IsFolderByClass = True
    If folderPath <> "" Then 
        Set tmpCFile = New cFile 
        tmpCFile.Initialize folderPath , ftype
        IsFolderByClass = tmpCFile.IsFolder
    End If
    
    Set tmpCFile = Nothing
End Function


'-------------------------------------------------------------------------------------
' MyGetPersistentVal
'  Get Persistent value
'----------------------
Function MyGetPersistentVal(key, defualt)
    MyGetPersistentVal = defualt
    tmpVal= Salamander.GetPersistentVal(key)
    If Not IsNull(tmpVal) Then 
        MyGetPersistentVal = tmpVal
    End If
End Function


'-------------------------------------------------------------------------------------
' SetWinSCPPath
'  Set WinSCP file path
'----------------------
Function SetWinSCPPath
    Salamander.MsgBox("Undefined WinSCP path" & WinSCP_path)
    Dim fm 
    Set fm = Salamander.Forms.Form("WinSCP")
    fm.infLbl = Salamander.Forms.Label("Script is unable to find your winSCP home directory.")
    fm.dstLbl = Salamander.Forms.Label("WinSCP directory:")
    fm.dst = Salamander.Forms.TextBox("C:\Program Files\WinSCP")
    fm.checkbox = Salamander.Forms.CheckBox("Save path to persistent memory")
    
    fm.okbtn = Salamander.Forms.Button("Ok", 1)
    fm.cancelbtn = Salamander.Forms.Button("Cancel", 2)
    
    Do While True
        If fm.execute = 1 Then
            If IsFile ( fm.dst.Text & "\WinSCP.com" ) Then 
                SetWinSCPPath = fm.dst.Text
                If fm.checkbox.Checked = True Then
                    Salamander.SetPersistentVal "compare.winscp", fm.dst.Text
                End If
                Exit Do
            End If
            
        Else 
            SetWinSCPPath = -1
            Exit Do
        End If
    Loop
    Set fm = Nothing
    
End Function


'-------------------------------------------------------------------------------------
' SetComparePath
'  Set file comparator path
'--------------------------
Function SetComparePath
    Salamander.MsgBox("Undefined fcremtoe path")
    Dim fm 
    Set fm = Salamander.Forms.Form("fcremote")
    fm.infLbl = Salamander.Forms.Label("Script is unable to find your fcremote home directory.")
    fm.dstLbl = Salamander.Forms.Label("fcrempte directory:")
    fm.dst = Salamander.Forms.TextBox("C:\Program Files\Altap Salamander\plugins\filecomp")
    fm.checkbox = Salamander.Forms.CheckBox("Save path to persistent memory")
    
    fm.okbtn = Salamander.Forms.Button("Ok", 1)
    fm.cancelbtn = Salamander.Forms.Button("Cancel", 2)
    
    Do While True
        If fm.execute = 1 Then
            If IsFile ( fm.dst.Text & "\fcremote.exe" ) Then 
                SetComparePath = fm.dst.Text
                If fm.checkbox.Checked = True Then
                    Salamander.SetPersistentVal "compare.fcremote", fm.dst.Text
                End If
                Exit Do
            End If
            
        Else 
            SetComparePath = -1
            Exit Do
        End If
    Loop
    
    Set fm = Nothing
    
End Function


'-------------------------------------------------------------------------------------
' O W N   C L A S S E S
'-------------------------------------------------------------------------------------

'-------------------------------------------------------------------------------------
' Class cFile
'  zakladni handling pro soubory
'-------------------------------
Class cFile
    Private mFilePath
    Private mFileName
    Private mFullPath
    Private mFileSize
    Private mAttibutes
    Private mIsFile
    Private mFileType
    Private mFileSystem ' SFTP, LOCAL_DISK, FTP, ARCHIVE,...
    
    Public Property Get IsFile
        IsFile = mIsFile
    End Property
        
    Public Property Get IsFolder
        IsFolder = Not mIsFile
    End Property
        
    Public Property Get FileSystem
        FileSystem = mFileSystem
    End Property
        
    Public Property Get FullPath
        FullPath = mFullPath
    End Property
    
    Public Property Get Path
        Path = mFilePath
    End Property
    
    Public Property Get Name
        Name = mFileName
    End Property
    
    Public Property Get Size
        Size = mFileSize
    End Property

    Sub Initialize (sFile, sType)
        mFullPath = sFile.Path
        mFileName = sFile.Name
        mFilePath = Left( mFullPath, Len(mFullPath) - Len(mFileName) )
        mFileSize = sFile.Size
        mAttibutes = sFile.Attributes
        mFileType = sType
        
        initIsFile
        SetFileSystem
        
        ' Substitute \ fo / in SFTP path
        If mFileSystem = "SFTP" Then
            mFullPath = Replace (mFullPath, "\","/")
            mFilePath = Replace (mFilePath, "\","/")
        End If
    End Sub
    
    Private Sub initIsFile
        If mFileType = 1 Then
            mIsFile = Not cIsFolder(mFullPath)
        ElseIf mFileType = 3 Then
            ' Dirty hack for recognize that is focuse FILE. May not works everywhere
            If mAttibutes < 16 Then
                mIsFile = True
            End If
        End If
    End Sub


    Private Sub SetFileSystem
        If mFileType = 1 Then
            mFileSystem = "LOCAL"  ' Local file
        ElseIf mFileType = 2 Then
            mFileSystem = "ARCH"  ' Archive
        ElseIf mFileType = 3 Then
            If InStr(mFullPath,"sftp://") = 1 Then
                mFileSystem = "SFTP"  ' SFTP
            Else
                mFileSystem = "UNK"  ' Unknown
            End If
        Else
            mFileSystem = "UNK"  ' Unknown
        End If
    End Sub


    Private Function cIsFolder(folder)
        cIsFolder = False
        Dim objFSO
        Set objFSO = CreateObject("Scripting.FileSystemObject")
        If objFSO.FolderExists(folder) Then 
            cIsFolder = True
        End If
        Set objFSO = Nothing
    End Function


    ' Constructor
    Private Sub Class_Initialize
        mIsFile = False
        mFileSystem = "UNK"
    End Sub
 
    ' Destructor
    Private Sub Class_Terminate

    End Sub

End Class

